using UnityEngine;
using UnityEngine.SceneManagement;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
          CategoryBuilder.Create("Stickmen", "This mod adds stickmen from the game Stick Fight the Game", ModAPI.LoadSprite("category.png"));

          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                  NameOverride = "Green Stickman", //new item name with a suffix to assure it is globally unique
                  DescriptionOverride = "Green Stickman from game Stick Fight the Game", //new item description
                  CategoryOverride = ModAPI.FindCategory("Stickmen"), //new item category
                  ThumbnailOverride = ModAPI.LoadSprite("GreenStickman.png"), //new item thumbnail (relative path)
                  AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                  {
                      //load textures for each layer (see Human textures folder in this repository)
                      var skin = ModAPI.LoadTexture("SkinGreenStickman.png");
                      var flesh = ModAPI.LoadTexture("Flesh.png");
                      var bone = ModAPI.LoadTexture("Bone.png");

                      //get person
                      var person = Instance.GetComponent<PersonBehaviour>();


                      //use the helper function to set each texture
                      //parameters are as follows:
                      //  skin texture, flesh texture, bone texture, sprite scale
                      //you can pass "null" to fall back to the original texture
                      person.SetBodyTextures(skin, flesh, bone, 1);

                      foreach (var body in person.Limbs)
                {
                  body.BaseStrength *= 1f;
                  body.Health *= 5f;
                  body.BreakingThreshold *= 1f;
                    }

                      //change procedural damage colours if they interfere with your texture (rgb 0-255)
                      person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                      person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                      person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                      person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                      person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                  NameOverride = "Blue Stickman", //new item name with a suffix to assure it is globally unique
                  DescriptionOverride = "Blue Stickman from game Stick Fight the Game", //new item description
                  CategoryOverride = ModAPI.FindCategory("Stickmen"), //new item category
                  ThumbnailOverride = ModAPI.LoadSprite("BlueStickman.png"), //new item thumbnail (relative path)
                  AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                  {
                      //load textures for each layer (see Human textures folder in this repository)
                      var skin = ModAPI.LoadTexture("SkinBlueStickman.png");
                      var flesh = ModAPI.LoadTexture("Flesh.png");
                      var bone = ModAPI.LoadTexture("Bone.png");

                      //get person
                      var person = Instance.GetComponent<PersonBehaviour>();


                      //use the helper function to set each texture
                      //parameters are as follows:
                      //  skin texture, flesh texture, bone texture, sprite scale
                      //you can pass "null" to fall back to the original texture
                      person.SetBodyTextures(skin, flesh, bone, 1);

                      foreach (var body in person.Limbs)
                {
                  body.BaseStrength *= 1f;
                  body.Health *= 5f;
                  body.BreakingThreshold *= 1f;
                    }

                      //change procedural damage colours if they interfere with your texture (rgb 0-255)
                      person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                      person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                      person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                      person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                      person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                  NameOverride = "Red Stickman", //new item name with a suffix to assure it is globally unique
                  DescriptionOverride = "Red Stickman from game Stick Fight the Game", //new item description
                  CategoryOverride = ModAPI.FindCategory("Stickmen"), //new item category
                  ThumbnailOverride = ModAPI.LoadSprite("RedStickman.png"), //new item thumbnail (relative path)
                  AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                  {
                      //load textures for each layer (see Human textures folder in this repository)
                      var skin = ModAPI.LoadTexture("SkinRedStickman.png");
                      var flesh = ModAPI.LoadTexture("Flesh.png");
                      var bone = ModAPI.LoadTexture("Bone.png");

                      //get person
                      var person = Instance.GetComponent<PersonBehaviour>();


                      //use the helper function to set each texture
                      //parameters are as follows:
                      //  skin texture, flesh texture, bone texture, sprite scale
                      //you can pass "null" to fall back to the original texture
                      person.SetBodyTextures(skin, flesh, bone, 1);

                      foreach (var body in person.Limbs)
                {
                  body.BaseStrength *= 1f;
                  body.Health *= 5f;
                  body.BreakingThreshold *= 1f;
                    }

                      //change procedural damage colours if they interfere with your texture (rgb 0-255)
                      person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                      person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                      person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                      person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                      person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                  }
              }
          );
          ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
                  NameOverride = "Yellow Stickman", //new item name with a suffix to assure it is globally unique
                  DescriptionOverride = "Yellow Stickman from game Stick Fight the Game", //new item description
                  CategoryOverride = ModAPI.FindCategory("Stickmen"), //new item category
                  ThumbnailOverride = ModAPI.LoadSprite("YellowStickman.png"), //new item thumbnail (relative path)
                  AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
                  {
                      //load textures for each layer (see Human textures folder in this repository)
                      var skin = ModAPI.LoadTexture("SkinYellowStickman.png");
                      var flesh = ModAPI.LoadTexture("Flesh.png");
                      var bone = ModAPI.LoadTexture("Bone.png");

                      //get person
                      var person = Instance.GetComponent<PersonBehaviour>();


                      //use the helper function to set each texture
                      //parameters are as follows:
                      //  skin texture, flesh texture, bone texture, sprite scale
                      //you can pass "null" to fall back to the original texture
                      person.SetBodyTextures(skin, flesh, bone, 1);

                      foreach (var body in person.Limbs)
                {
                  body.BaseStrength *= 1f;
                  body.Health *= 5f;
                  body.BreakingThreshold *= 1f;
                    }

                      //change procedural damage colours if they interfere with your texture (rgb 0-255)
                      person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                      person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                      person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                      person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                      person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered

                  }
              }
          );
          ModAPI.Register(
                                        new Modification()
                                        {
                                            OriginalItem = ModAPI.FindSpawnable("Stick"),
                                            NameOverride = "Crown",
                                            NameToOrderByOverride = "Helmet",
                                            DescriptionOverride = "",
                                            CategoryOverride = ModAPI.FindCategory("Stickmen"),
                                            ThumbnailOverride = ModAPI.LoadSprite("CrownView.png", 5f),
                                            AfterSpawn = (Instance) =>
                                            {
                                                Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Crown.png", 1f);
                        						ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                                                armor.stabResistance = 10f;
                                                armor.armorPiece = "Head";
                                                armor.armorTier = 1;

                        						Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                        						Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                                                Instance.FixColliders();
                                            }
                                        }
                                    );

        }
    }
}
